const bdd = require("./bdd.js").bdd;
const DEBUG = require("../utils/debug").DEBUG;

function registerMessage(timestamp, rfc822size, messageId) {
    return new Promise((resolve, reject) => {
        const query = `INSERT INTO message (idate, messageID, rfc822size) VALUES (${timestamp}, '${messageId}', '${rfc822size}')`;
        bdd.query(query, (err, results, fields) => {
            if (err) reject(err);
            resolve(results.insertId);
        });
    });
}

function registerMailbox_message(mailboxId, uid, messageId, modseq, seen, deleted) {
    const query = `INSERT IGNORE INTO mailbox_message (mailbox_id, uid, message_id, modseq, seen, deleted) VALUES ('${mailboxId}', '${uid}', '${messageId}', '${modseq}', '${seen}', '${deleted}')`;
    bdd.query(query, (err, results, fields) => {
        if (err) DEBUG.log(err);
    });
}

function registerBodypart(messageId, part, bodypartId, bytes, nbLines) {
    const query = `INSERT IGNORE INTO part_number (message_id, part, bodypart, bytes, nbLines) VALUES ('${messageId}', '${part}', '${bodypartId}', '${bytes}', '${nbLines}')`;
    bdd.query(query, (err, results, fields) => {
        if (err) DEBUG.log(err);
    });
}


function saveBodypart(bytes, hash, text, data) {
    return new Promise((resolve, reject) => {
    const query = `INSERT IGNORE INTO bodypart (bytes, hash, text, data) VALUES ('${bytes}', '${hash}', '${text}', '${data}')`;
        bdd.query(query, (err, results, fields) => {
            if (err) reject(err);
            resolve(results.insertId);
        });
    });
}

function saveHeader_fields(message, part, position, field, value) {
    const query = `INSERT IGNORE INTO header_field (message_id, part, position, field_id, value) VALUES ('${message}', '${part}', '${position}', '${field}', '${value}')`;
    bdd.query(query, (err, results, fields) => {
        if (err) throw err;
    }); 
}

function saveAddress_fields(message, part, position, field, number, address) {
    const query = `INSERT IGNORE INTO address_field (message_id , part, position, field_id, number, address_id) VALUES ('${message}', '${part}', '${position}', '${field}', '${number}', '${address}')`;
    bdd.query(query, (err, results, fields) => {
        if (err) throw err;
    }); 
}

module.exports = {
    registerMessage,
    registerMailbox_message,
    saveHeader_fields,
    saveAddress_fields,
    registerBodypart,
    saveBodypart,
}